package com.bsdenterprise.flutter_mqtt_plugin.utilities;

import com.amazonaws.services.iot.client.AWSIotMessage;
import com.amazonaws.services.iot.client.AWSIotQos;

public class MqttMessage extends AWSIotMessage {

    private MqttCallback callback;

    public MqttMessage(String topic, AWSIotQos qos, String payload, MqttCallback callback) {
        super(topic, qos, payload);
        this.callback = callback;
    }

    @Override
    public void onSuccess() {
        super.onSuccess();
        this.callback.onSendSuccess();
    }

    @Override
    public void onFailure() {
        super.onFailure();
        this.callback.onSendFailure();
    }

    @Override
    public void onTimeout() {
        super.onTimeout();
        this.callback.onSendTimeout();
    }
}
