package com.bsdenterprise.flutter_mqtt_plugin.utilities;

import com.amazonaws.services.iot.client.AWSIotMessage;
import com.amazonaws.services.iot.client.AWSIotQos;
import com.amazonaws.services.iot.client.AWSIotTopic;

public class MqttTopic extends AWSIotTopic {

    private MqttCallback callback;

    public MqttTopic(String topic, AWSIotQos qos, MqttCallback callback) {
        super(topic, qos);
        this.callback = callback;
    }

    @Override
    public void onMessage(AWSIotMessage message) {
        super.onMessage(message);
        this.callback.onMessage(message);
    }

    @Override
    public void onSuccess() {
        super.onSuccess();
        this.callback.onSubscribeSuccess();
    }

    @Override
    public void onFailure() {
        super.onFailure();
        this.callback.onSubscribeFailure();
    }

    @Override
    public void onTimeout() {
        super.onTimeout();
        this.callback.onSubscribeTimeout();
    }
}
