
import 'dart:async';

import 'package:flutter/services.dart';

class FlutterMqttPlugin {
  static const MethodChannel _channel = const MethodChannel('mqtt.methods');
  static const EventChannel _eventChannel = const EventChannel('mqtt.events');
  
  static Stream<dynamic> listenEvents() {
    return _eventChannel.receiveBroadcastStream();
  }

  static void connect(String clientEndpoint, String certificate, String privateKey) async {
    _channel.invokeMethod('connect', {
      "clientEndpoint": clientEndpoint,
      "certificate": certificate,
      "privateKey": privateKey
    });
  }

  static void disconnect() async {
    _channel.invokeMethod('disconnect');
  }

  static void subscribe(String topicName) async {
    _channel.invokeMethod('subscribe', {
      "topicName": topicName
    });
  }

  static Future<String> publish(String topicName, String payload) async {
    return await _channel.invokeMethod('publish', {
      "topicName": topicName,
      "payload": payload
    });
  }
}
